﻿----------------------------------------
-- Epic Gem List v 0.2, Copyright 2010 Wolfgang Rufeger, wolfgang@rufeger.de
-- 0.1	Initial version
-- 0.2	Added blue cataclysm gems with test on first load
----------------------------------------
EGL_SOCKETSELECT = EGL_GemLocaleText["socketselect"];
EGL_STATSELECT = EGL_GemLocaleText["statselect"];
EGL_CLOSE = EGL_GemLocaleText["close"];


local ldb = LibStub:GetLibrary("LibDataBroker-1.1",true)

ldb:NewDataObject("EPICGEMLIST", {
    type = "data source",
	label = "EpicGemList",
	OnClick = function(_, msg)
        if msg == "LeftButton" then
	        if EGL_Form:IsVisible() then
		        EGL_Form:Hide()
		    else
		        EGL_Form:Show()
	        end
        end
    end,
	icon = "Interface\\AddOns\\EpicGemList\\icon",
	OnTooltipShow = function(tooltip)
		if not tooltip or not tooltip.AddLine then return end
		tooltip:AddLine("EpicGemList")
	end,
})

if(EGL_Options == nil) then
    EGL_Options = {};
end

if ( EGL_Options["SelectedStat"]  == nil ) then
    EGL_Options["SelectedStat"] = 0;
end

if ( EGL_Options["SelectedSlot"] == nil ) then
    EGL_Options["SelectedSlot"] = 0;
end

function out(text)
 DEFAULT_CHAT_FRAME:AddMessage(text)
 --UIErrorsFrame:AddMessage(text, 1.0, 1.0, 0, 1, 10) 
end




function EGL_SlashCommandHandler(msg)
	if (msg == "cata") then
		if (EGL_Options["cataclysm"]) then
			EGL_Options["cataclysm"] = false;
			out("EGL: Cataclysm support disabled ...");
		else
			EGL_Options["cataclysm"] = true;
			out("EGL: Cataclysm support enabled ...");
		end
	else
		if EGL_Form:IsVisible() then
			EGL_Form:Hide()
		else
			EGL_Form:Show()
		end
	end
end


function EGL_OnLoad(this)
	SELECTEDITEM = 0;
  
	out("EpicGemList Loaded...");
	SLASH_EGL1 = "/epicgemlist";
	SLASH_EGL2 = "/egl";
	SlashCmdList["EGL"] = function(msg)
		EGL_SlashCommandHandler(msg);
	end
	if EGL_Form:IsVisible() then
		EGL_Form:Hide()
	else
		EGL_Form:Show()
	end
	EGL_Options = {};
	EGL_Options["SelectedSlot"] = 0;
	EGL_Options["SelectedStat"] = 0;
	iteminfo = GetItemInfo(52203); -- test on one cataclysm gem
	if iteminfo then
		EGL_Options["cataclysm"] = true;
	else
		EGL_Options["cataclysm"] = false;
	end
	EGL_SlotDropDown_Init();
	EGL_StatDropDown_Init();
end

function EGLItem_OnEnter(this)
  EGLTooltip:ClearLines();
  local id = this:GetID()+ FauxScrollFrame_GetOffset(EGL_ScrollBar);  
  
  if id ~= nil then
  	local iteminfo = GetItemInfo(EGL[id]);
    local itemName, itemLink, itemQuality, itemLevel, itemMinLevel, itemType, itemSubType, itemCount, itemEquipLoc, itemTexture = GetItemInfo(EGL[id]);

    EGLTooltip:SetOwner(this, "ANCHOR_RIGHT", -(this:GetWidth() / 2), 24);
    EGLTooltip:SetHyperlink("item:"..EGL[id]..":0:0:0");
    EGLTooltip:Show();

	if EnhTooltip and EnhTooltip.TooltipCall then   
	  quantity = 1;
	  EnhTooltip.TooltipCall(EGLTooltip, itemName, itemLink, itemQuality, quantity);
	end
  end 
end

function EGLItem_OnLeave()
  SELECTEDITEM = 0;
  EGLTooltip:Hide();
end

function EGLItem_OnClick(this)
	local id = this:GetID() + FauxScrollFrame_GetOffset(EGL_ScrollBar);
	local iteminfo = GetItemInfo(EGL[id]);
    local itemName, itemLink, itemQuality, itemLevel, itemMinLevel, itemType, itemSubType, itemCount, itemEquipLoc, itemTexture = GetItemInfo(EGL[id])
	local editbox = ChatFrameEditBox
	if not editbox then
		editbox = ChatEdit_GetActiveWindow();
    end 
    if AuctionFrame then
        if (AuctionFrame:IsVisible() and CanSendAuctionQuery() and iteminfo) then
            BrowseName:SetText(itemName);
            AuctionFrameBrowse_Search();
        end
    end
	if (editbox and IsShiftKeyDown()) then
		editbox:Insert(itemLink); 
	end
end


function EGL_SlotDropDown_Init()
	local entries = table.getn(EGL_GemLocaleSlot);
	for i=0,entries do
		info = {};
		value = i;
		text = EGL_GemLocaleSlot[i];
		info.value = value;
		info.text = text;
		info.func = EGL_SlotDropDown_OnClick;
		UIDropDownMenu_AddButton(info);
	end
end

function EGL_SlotDropDown_OnShow()
    UIDropDownMenu_Initialize(EGL_SlotDropDown, EGL_SlotDropDown_Init);
    UIDropDownMenu_SetSelectedID(EGL_SlotDropDown, EGL_Options["SelectedSlot"]+1);
    -- UIDropDownMenu_SetWidth(110, EpicGemListSlotDropDown);
    EGL_ScrollBar_Update();
end

function EGL_SlotDropDown_OnClick(this)
    i = this:GetID();
    UIDropDownMenu_SetSelectedID(EGL_SlotDropDown, i);
    EGL_Options["SelectedSlot"] = i-1;
    EGL_ScrollBar_Update();
end

function EGL_StatDropDown_Init()
	local entries = table.getn(EGL_GemLocaleStat);
	for i=0,entries do
		info = {};
		value = i;
		text = EGL_GemLocaleStat[i];
		info.text = text;
		info.value = value;
		info.func = EGL_StatDropDown_OnClick;
		UIDropDownMenu_AddButton(info);
	end
end

function EGL_StatDropDown_OnShow()
    UIDropDownMenu_Initialize(EGL_StatDropDown, EGL_StatDropDown_Init);
    UIDropDownMenu_SetSelectedID(EGL_StatDropDown, EGL_Options["SelectedStat"]+1);
    -- UIDropDownMenu_SetWidth(110, EpicGemListSlotDropDown);
    EGL_ScrollBar_Update();
end

function EGL_StatDropDown_OnClick(this)
    i = this:GetID();
    UIDropDownMenu_SetSelectedID(EGL_StatDropDown, i);
    EGL_Options["SelectedStat"] = i-1;
    EGL_ScrollBar_Update();
end


function EGL_ScrollBar_Update()
    local line, lineplusoffset, text, extratext;
    local currentgem;    
    EGL = {};    
    currentgem = 1;

    for value,_ in pairs(EGL_Data) do    
	    additem = true;	    	    
		if EGL_Options["SelectedStat"] ~= 0 and 
		   (EGL_Data[value]["stat1"] ~= EGL_Options["SelectedStat"] and EGL_Data[value]["stat2"] ~= EGL_Options["SelectedStat"] and EGL_Data[value]["stat3"] ~= EGL_Options["SelectedStat"]) then
			additem = false;
	    end	    
	    if EGL_Options["SelectedSlot"] ~= 0 and 
	           ((EGL_Options["SelectedSlot"] == 1 and EGL_Data[value]["red"] == false) or
			   (EGL_Options["SelectedSlot"] == 2 and EGL_Data[value]["blue"] == false) or
			   (EGL_Options["SelectedSlot"] == 3 and EGL_Data[value]["yellow"] == false) or
			   (EGL_Options["SelectedSlot"] == 4 and EGL_Data[value]["meta"] == false)) then
			additem = false;   
		end	    
        if additem == true then
            tinsert(EGL, value);
        end        
        currentgem = currentgem + 1;
    end      
	
	if (EGL_Options["cataclysm"]) then	-- if info of cataclysm gems can be retrieved
		for value,_ in pairs(EGL_Data_Cata) do    
			additem = true;	    	    
			if EGL_Options["SelectedStat"] ~= 0 and 
			(EGL_Data_Cata[value]["stat1"] ~= EGL_Options["SelectedStat"] and EGL_Data_Cata[value]["stat2"] ~= EGL_Options["SelectedStat"] and EGL_Data_Cata[value]["stat3"] ~= EGL_Options["SelectedStat"]) then
				additem = false;
			end	    
			if EGL_Options["SelectedSlot"] ~= 0 and 
			((EGL_Options["SelectedSlot"] == 1 and EGL_Data_Cata[value]["red"] == false) or
			(EGL_Options["SelectedSlot"] == 2 and EGL_Data_Cata[value]["blue"] == false) or
			(EGL_Options["SelectedSlot"] == 3 and EGL_Data_Cata[value]["yellow"] == false) or
			(EGL_Options["SelectedSlot"] == 4 and EGL_Data_Cata[value]["meta"] == false)) then
				additem = false;   
			end	    
			if additem == true then
				tinsert(EGL, value);
			end        
			currentgem = currentgem + 1;
		end      
	end
    table.sort(EGL, EGL_SortResults);
    EGL_ShowGemList();    
end

function EGL_SortResults(a, b)
    local itemNameA, itemLinkA, itemQualityA, itemLevelA = GetItemInfo(a);
    local itemNameB, itemLinkB, itemQualityB, itemLevelB = GetItemInfo(b);
	if itemLevelA ~= itemLevelB then	-- Sort by item level first
		return itemLevelA > itemLevelB;
	end
	if itemQualityA ~= itemQualityB then	-- Sort by item quality second
		return itemQualityA > itemQualityB;
	end
	if itemNameA and itemNameB then		-- if same item level, sort by name
		return itemNameA < itemNameB;
	end
	return a < b;						-- sort by id, if no name
end

function EGL_ShowGemList()  
	local i, item, itemn;
    MaxItems = table.getn(EGL);    
    FauxScrollFrame_Update(EGL_ScrollBar,MaxItems,15,16);
    for i=1,15 do
		item = _G["EGLItem_"..i];
		itemn = _G["EGLItem_"..i.."_Name"];
        lineplusoffset = i + FauxScrollFrame_GetOffset(EGL_ScrollBar);
		if lineplusoffset < MaxItems+1 then
			itemName, itemLink, itemRarity = GetItemInfo(EGL[lineplusoffset]);
			if itemName then
				if itemn ~= nil then
					itemn:SetText(ITEM_QUALITY_COLORS[itemRarity].hex..itemName);
				end
				if item ~= nil then
					item:Show();
				end
			end
		else
			if item ~= nil then
				item:Hide();
			end
		end
    end
end

